
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript11 : EcoBase
{



public readonly WaterAction action;

public EcoScript11 (Scene scene, WaterAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript11"
// Calculate waterheights

void PrepareSuccession() {
}

// we assume here that we use a Bitmap2 for canals
// and thus have only values 0..3
public int[] distanceConversion = new int[] { 0, 4, 6, 8 };

// convert distance value to effective waterheight change
// needs n values, where n is height number in distanceConversion
// array
public float[] heightEffect = new float[] { 0f, 0.05f, 0.1f, 0.15f, 0.2f, 0.25f, 0.3f, 0.35f, 0.4f };

void DoSuccession() {
	if (progression.GetData (Progression.CANAL_ID).hasChanged) {
		CalculateWater ();
	}
}

void CalculateWater() {
	Data canals = progression.GetData (Progression.CANAL_ID);
		
	BitMap8 distanceMap = progression.GetData<BitMap8>("canaldistance");
	distanceMap.Clear ();
	foreach (ValueCoordinate vc in canals.EnumerateNotZero ()) {
		distanceMap.Set (vc, distanceConversion [vc.v]);
	}
	while (distanceMap.Propagate ()) {
		// keeps being called until propagate is ready...
	}
	HeightMap land = progression.GetData<HeightMap>(Progression.HEIGHTMAP_ID);
	HeightMap staticWater = progression.GetData<HeightMap>(Progression.WATERHEIGHTMAP_ID);
	HeightMap calculated = progression.GetData<HeightMap>(Progression.CALCULATED_WATERHEIGHTMAP_ID);
	calculated.CopyFrom (staticWater);
	
	// the canals will push water levels lower if needed.
	// for this we look at all cells that have a distanceMap value != 0
	// the new water height will be the minimum of the current waterheight
	// and the land height - height delta forced by canal (distanceMap)
	distanceMap.ProcessNotZero(delegate (int x, int y, int val, object ignore) {
		if (val > 0) {
			float expectedWaterHeight = land.GetHeight (x, y) - heightEffect[val];
			float waterHeight = calculated.GetHeight (x, y);
			if (expectedWaterHeight < waterHeight) {
				// canal will lower water!
				calculated.SetHeight (x, y, expectedWaterHeight);
			}
		}
	}, null);
}
}
