
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript1 : EcoBase
{



public readonly ScriptAction action;

public EcoScript1 (Scene scene, ScriptAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript1"
// Zonnebaars

void PrepareSuccession() {
}


void DoSuccession() {
	CalculateGrowth (0);
	CalculateGrowth (1);
	CalculateGrowth (2);
	DisperseBetweenVens ();
	Data zb = progression.GetData("ZB");
	zb.Clear ();
}

/**
 * Calculates new population sizes of ZonneBaars
 */
void CalculateGrowth (int venNr) {
	int breedingArea = BreedingAreaZB [venNr];
	float maxBirth = (float) (breedingArea * ZBBorderCap [venNr]);
	float pop0 = ZonneBaars [venNr];
	float death = ZBMort * pop0;
	float birth = System.Math.Min ((pop0 - death) * ZBBirthRate, maxBirth);
	float pop1 = System.Math.Max(pop0 - death + birth, 0);
	float eatenBySnoek = SnoekPredateOnZB * Snoek [venNr] * (pop1 / (pop1 + Snoek [venNr] + 0.01f));
	float eatenByZB = ZBPredateOnZB * pop1 * (Snoek [venNr] / (pop1 + Snoek [venNr] + JuvKP [venNr] + 0.01f));
	pop1 = System.Math.Max (pop1 - eatenBySnoek - eatenByZB, 0f);
	ZonneBaars [venNr] = (int) pop1;
}

/**
 * there's a chance the ZB moves between different vens
 */
void DisperseBetweenVens () {
	if (GridIsPlaced) return;
	System.Random rnd = new System.Random ();
	double populationVen0 = (double) ZonneBaars[0];
	double populationVen1 = (double) ZonneBaars[1];
	double m0to1 = (rnd.NextDouble () + rnd.NextDouble ()) * populationVen0 * DispersionVen0To1;
	double m1to0 = (rnd.NextDouble () + rnd.NextDouble ()) * populationVen1 * DispersionVen1To0;
	if (OverflowIsPlaced) {
		m1to0 = 0; // no migration from ven 1 to 0 when overflow is placed
	}
	populationVen0 = populationVen0 - m0to1 + m1to0;
	populationVen1 = populationVen1 + m0to1 - m1to0;
	ZonneBaars[0] = (int) populationVen0;
	ZonneBaars[1] = (int) populationVen1;
}


/**
 * Helper function to calculate number of water tiles and number of
 * border tiles in a ven.
 */
void CountTiles (int venNr) {
	Data ven = progression.GetData("Ven" + venNr);
	Data breedingMap = progression.GetData("BreedingZB");
	int tileCount = 0;
	int breedingAreaCount = 0;
	foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
		tileCount ++;
		if (breedingMap.Get (vc) != 0) {
			breedingAreaCount ++;
		}
	}
	BreedingAreaZB [venNr] = breedingAreaCount;
	TileCount [venNr] = tileCount;
	LogDebug ("Ven " + venNr + " tileCount = " + tileCount + " breeding area = " + breedingAreaCount);
}

void CopyBorderToBreedingZB () {
	Data border = progression.GetData ("Border");
	border.CopyTo (progression.GetData ("BreedingZB"));
}

void Debug (string arg) {
	LogDebug ("Arg = '" + arg + "'");
	if (arg == "setupcounts") {
		CountTiles (0);
		CountTiles (1);
		CountTiles (2);
	}
	else if (arg == "succession") {
		DoSuccession ();
	}
	else {
		LogError ("Unknown argument '" + arg + "' supported are 'setupcounts', 'succession'");
	}
}
}
