
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript26 : EcoBase
{



public readonly ScriptAction action;

public EcoScript26 (Scene scene, ScriptAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript26"
// DISTRIBUTE Zonnebaars/KP/Snoek

/**
 * Actually places the zonnebaars in the ven using the total counts per ven
 */
void DistributeZB (int venNr) {
	int population = ZonneBaars [venNr];
	int tileCount = TileCount [venNr];
	Data ven = progression.GetData("Ven" + venNr);
	Data zb = progression.GetData("ZB");
	
	if (population <= 0) return;
	
	float avgNrZBPerTile = (float) population / (float) tileCount;
	int total = 0;
	
	System.Random rnd = new System.Random ();
	
	// I'm horrible at statistics so for easy distribution I look at two cases
	// when there are avg less that 1 ZB per tile and when there are avg
	// >= 1 ZB per tile...
	if (avgNrZBPerTile < 1f) {
		float doubleC = avgNrZBPerTile * avgNrZBPerTile;
		float singleC = avgNrZBPerTile - doubleC;
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			double chance = rnd.NextDouble ();
			if (chance <= doubleC) {
				zb.Set (vc, 2); // we got two zb on the tile
				total += 2;
			}
			else if (chance <= singleC) {
				zb.Set (vc, 1); // we got one zb on the tile
				total += 1;
			}
		}
	}
	else {
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			int nrZBForTile = (int) ((rnd.NextDouble () + rnd.NextDouble ()) * avgNrZBPerTile + 0.5);
			if (nrZBForTile > 0) {
				if (nrZBForTile > ZBCarryingCap) {
					zb.Set (vc, ZBCarryingCap);
					total += ZBCarryingCap;
				}
				else {
					zb.Set (vc, nrZBForTile);
					total += nrZBForTile;
				}
			}
		}
	}
	LogDebug ("ZONNEBAARS For Ven " + venNr + " population " + population + " actual placed " + total);
	ZonneBaars [venNr] = total;
}

/**
 * Actually places the JuvKP in the ven using the total counts per ven
 */
void DistributeJuvKP (int venNr) {
	int population = JuvKP [venNr];
	int tileCount = TileCount [venNr];
//	int borderCount = BorderCount [venNr];
	Data ven = progression.GetData("Ven" + venNr);
	Data zb = progression.GetData("JuvKP");
	
	if (population <= 0) return;
	
	float avgNrJuvJPPerTile = (float) population / (float) tileCount;
	int total = 0;
	
	System.Random rnd = new System.Random ();
	
	// I'm horrible at statistics so for easy distribution I look at two cases
	// when there are avg less that 1 ZB per tile and when there are avg
	// >= 1 ZB per tile...
	if (avgNrJuvJPPerTile < 1f) {
		float doubleC = avgNrJuvJPPerTile * avgNrJuvJPPerTile;
		float singleC = avgNrJuvJPPerTile - doubleC;
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			double chance = rnd.NextDouble ();
			if (chance <= doubleC) {
				zb.Set (vc, 2); // we got two zb on the tile
				total += 2;
			}
			else if (chance <= singleC) {
				zb.Set (vc, 1); // we got one zb on the tile
				total += 1;
			}
		}
	}
	else {
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			int nrJuvKPForTile = (int) ((rnd.NextDouble () + rnd.NextDouble ()) * avgNrJuvJPPerTile + 0.5f);
			if (nrJuvKPForTile > 0) {
				if (nrJuvKPForTile > JuvKPCarryingCap) {
					zb.Set (vc, JuvKPCarryingCap);
					total += JuvKPCarryingCap;
				}
				else {
					zb.Set (vc, nrJuvKPForTile);
					total += nrJuvKPForTile;
				}
			}
		}
	}
	LogDebug ("Juv KP For Ven " + venNr + " population " + population + " actual placed " + total);
	JuvKP [venNr] = total;
}

/**
 * Actually places the snoek in the ven using the total counts per ven
 */
void DistributeSnoek (int venNr) {
	int population = Snoek [venNr];
	int tileCount = TileCount [venNr];
	Data ven = progression.GetData("Ven" + venNr);
	Data snoek = progression.GetData("Snoek");
	
	if (population <= 0) return;
	
	float avgNrSnoekPerTile = (float) population / (float) tileCount;
	int total = 0;
	
	System.Random rnd = new System.Random ();
	
	// I'm horrible at statistics so for easy distribution I look at two cases
	// when there are avg less that 1 Snoek per tile and when there are avg
	// >= 1 Snoek per tile...
	if (avgNrSnoekPerTile < 1f) {
		float doubleC = avgNrSnoekPerTile * avgNrSnoekPerTile;
		float singleC = avgNrSnoekPerTile - doubleC;
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			double chance = rnd.NextDouble ();
			if (chance <= doubleC) {
				snoek.Set (vc, 2); // we got two snoek on the tile
				total += 2;
			}
			else if (chance <= singleC) {
				snoek.Set (vc, 1); // we got one snoek on the tile
				total += 1;
			}
		}
	}
	else {
		foreach (ValueCoordinate vc in ven.EnumerateNotZero ()) {
			int nrSnoekForTile = (int) ((rnd.NextDouble () + rnd.NextDouble ()) * avgNrSnoekPerTile + 0.5);
			if (nrSnoekForTile > 0) {
				if (nrSnoekForTile > SnoekCarryingCap) {
					snoek.Set (vc, SnoekCarryingCap);
					total += SnoekCarryingCap;
				}
				else {
					snoek.Set (vc, nrSnoekForTile);
					total += nrSnoekForTile;
				}
			}
		}
	}
	LogDebug ("Snoek For Ven " + venNr + " population " + population + " actual placed " + total);
	Snoek [venNr] = total;
}

void Distribute () {
	Data juvKP = progression.GetData("JuvKP");
	juvKP.Clear ();
	Data zb = progression.GetData("ZB");
	zb.Clear ();
	Data snoek = progression.GetData("Snoek");
	snoek.Clear ();
	for (int i = 0; i < 3; i++) {
		DistributeZB (i);
		DistributeJuvKP (i);
		DistributeSnoek (i);
	}
}

void DoSuccession() {
	Distribute ();
}

void Debug (string arg) {
	LogDebug ("Arg = '" + arg + "'");
	if (arg == "distribute") {
		Distribute ();
	}
	else {
		LogError ("Unknown argument '" + arg + "' supported are 'distribute'");
	}
}
}
