
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript27 : EcoBase
{


	protected const string AREA = "shallowermarker";


public readonly MarkerAction action;

public EcoScript27 (Scene scene, MarkerAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript27"
const string areaName = "verontdieparea";

void LoadProgress(bool initScene) {
	// for markers that are permanently visible, put them on map at load time
//	AddGameMarkers (AREA);
}

void HandleClick (Coordinate c) {
	Data data = progression.GetData (AREA);
	
	int val = data.Get (c);
	bool markerOn = (val >= 2);
	if (markerOn) {
		// was on, set to off
		data.Set (c, 1);
		action.uiList[0].estimatedTotalCostForYear -= action.uiList[0].cost;
	}
	else {
		// was off, set to on
		data.Set (c, 2);
		action.uiList[0].estimatedTotalCostForYear += action.uiList[0].cost;
	}
}

private SparseBitMap8 backup;
private long backupEstimate;

void ActionSelected (UserInteraction ui) {
	// we keep a backup of the data to be able to reset
	// it if user cancels action
	backup = new SparseBitMap8 (scene);
	backup.CopyFrom (progression.GetData<SparseBitMap8>(AREA));
	backupEstimate = action.uiList[0].estimatedTotalCostForYear;
	// put the markers on the map
	AddGameMarkers (AREA, new string[] { "shallowermarkeroff", "shallowermarkeron" }, HandleClick);
}

/**
 * user stops adding/removing markers
 */
void ActionDeselected (UserInteraction ui, bool cancel) {
	// remove the markers off the map
	RemoveGameMarkers (AREA);
	if (cancel) {
		action.uiList[0].estimatedTotalCostForYear = backupEstimate;
		backup.CopyTo (progression.GetData<SparseBitMap8>(AREA));
	}
	backup = null;
}

void PrepareSuccession() {
	// we handle this in prepare succession, as we want to have normal
	// succession change tiles of the selected vens.
	
	SparseBitMap8 markers = progression.GetData<SparseBitMap8>(AREA);
	markers.ProcessNotZero (delegate (int x, int y, int val, object ignore) {
		bool markerOn = (val >= 2);
		if (markerOn) {
			// marker was on, so do something useful here...
			for (int venNr = 0; venNr <= 2; venNr++) {
				Data ven = progression.GetData ("Ven" + venNr);
				if (ven.Get (x, y) > 0) {
					// found the ven marker is in...
					IsVerontdiept [venNr] = true;
					if (!progression.HasData (areaName)) {
						progression.AddData(areaName, new SparseBitMap1(scene));
					}
					Data verontdiepMap = progression.GetData(areaName);
					ven.ProcessNotZero(delegate (int x2, int y2, int val2, object ignore2) {
						verontdiepMap.Set (x2, y2, 1);
					}, null);
				}			
			}
			markers.Set (x, y, 0); // we remove marker...
		}
	}, null);
}

void KillAnimals (int venNr) {
	ZonneBaars [venNr] = 0;
	Snoek [venNr] = 0;
	JuvKP [venNr] = 0;
}

void DoSuccession() {

	System.Random rnd = new System.Random ();
	budget -= action.uiList[0].estimatedTotalCostForYear;
	action.uiList[0].estimatedTotalCostForYear = 0;
	
	if (rnd.NextDouble() <= 0.1) {
		// check if we qualify for drought...
		bool hasDrought = false;
		for (int venNr = 0; venNr < 3; venNr++) {
			if (IsVerontdiept [venNr]) {
				// we have a drought...
				LogDebug ("Drought detected... ven " + venNr);
				KillAnimals (venNr);
				hasDrought = true;
			}
		}
		if (hasDrought) {
			ShowArticle (13);
		}
	}
	
}

void FinalizeSuccession() {
	if (progression.HasData (areaName)) {
		// we have created the area in prepare succession for
		// making vegetation tiles transition to new type
		// we can now clear data
		progression.GetData (areaName).Clear();
	}
}
}
