
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript30 : EcoBase
{


	protected const string AREA = "area30";


public readonly InventarisationAction action;

public EcoScript30 (Scene scene, InventarisationAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript30"
// Fuikenvangst

string selectableArea = "biocidenmarker";
string knoflookpadNaam = "Spadefoot";
string zonnebaarsNaam = "Pumpkinseed Sunfish";
string snoekNaam = "Pike";

// 'legendIcon[X]Value', [X] corresponds with the
// #X in the survey action
int legendIcon1Value = 3;
int legendIcon2Value = 10;
int legendIcon3Value = 25;
// The fourth legend icon is used for every value
// higher than the 'legendIcon3Value'

void ProcessInventarisation (Inventarisation inv)
{
	// Get species
	kp = progression.GetData ("JuvKP");
	zb = progression.GetData ("ZB");
	sn = progression.GetData ("Snoek");

	// The selection of the inventarisation
	Data selection = inv.SelectionMap;
	
	// the resulting dataset
	// value 0 is used for all cells not selected in
	// the AREA map (not selected by user).
	// The icons map is used for visualisation.
	// The data map is used for recording the actual values.
	SparseBitMap8 kpIcons = new SparseBitMap8 (scene);
	SparseBitMap8 snIcons = new SparseBitMap8 (scene);
	SparseBitMap8 zbIcons = new SparseBitMap8 (scene);
	
	BitMap16 kpData = new BitMap16 (scene);
	BitMap16 snData = new BitMap16 (scene);
	BitMap16 zbData = new BitMap16 (scene);
	
	// Loop through all selected tiles (for different vens)
	int tileCount = 0; // we'll count the number of tiles selected
	foreach (Coordinate sc in selection.EnumerateNotZero ()) 
	{
		// Check which Ven we're surveying
		Data ven = null;
		int venIndex = 0;
		if (ven0.Get(sc.x, sc.y) > 0) {
			ven = ven0;
			venIndex = 1;
		} else if (ven1.Get(sc.x, sc.y) > 0) {
			ven = ven1;
			venIndex = 2;
		} else if (ven2.Get(sc.x, sc.y) > 0) {
			ven = ven2;
			venIndex = 3;
		} else {
			continue;
		}
		
		// We don't do anything if we didn't find a ven
		if (ven == null) continue;
		
		// Count the total of all species in the selected ven
		int totalKp = 0;
		int totalZb = 0;
		int totalSn = 0;
		
		foreach (Coordinate vc in ven.EnumerateNotZero ()) {
			tileCount ++;
			
			// Also save ZB and Snoek data
			totalKp += kp.Get (vc);
			totalZb += zb.Get (vc);
			totalSn += sn.Get (vc);
		}
		
		// Log all found values in in the Ven
		string log = "Total (non-biased) species in Ven " + (venIndex);
		log += "\n" + "Total JuvKP : " + totalKp;
		log += "\n" + "Total ZB : " + totalZb;
		log += "\n" + "Total Snoek : " + totalSn;
		LogDebug (log);
		
		// somehow map the values of the data we analyse
		// to the icons set...
		for (int i = 0; i < 3; i++)
		{
			// Get the species data etc.
			Data icons = null;
			Data data = null;
			int total = 0;
			string speciesName = "";
			switch (i) {
				case 0 :
					icons = kpIcons;
					data = kpData;
					total = totalKp;
					speciesName = "JuvKP";
					break;
				case 1 : 
					icons = zbIcons;
					data = zbData;
					total = totalZb;
					speciesName = "ZB";
					break;
				case 2 : 
					icons = snIcons;
					data = snData;
					total = totalSn;
					speciesName = "Snoek";
					break;
			}
			
			// Process bias
			total = ProcessBias (total, basicAction, inv.UIIndex);
			
			// Log processed bias
			LogDebug ("Biased total of " + speciesName + " : " + total);
			
			// Check which legend icon
			// we want to show
			if (total <= 0) {
				icons.Set (sc, 1);
			} else if (total <= legendIcon1Value) {
				icons.Set (sc, 2);
			} else if (total <= legendIcon2Value) {
				icons.Set (sc, 3);
			} else if (total <= legendIcon3Value) {
				icons.Set (sc, 4);
			} else {
				icons.Set (sc, 5);			
			}
			
			// Save the actual data (the biassed value).
			data.Set (sc, total);
		}
	}
	
	// Make the reports available.
	AddInventarisation (inv.Name + " " + knoflookpadNaam, kpIcons, kpData);
	AddInventarisation (inv.Name + " " + zonnebaarsNaam, zbIcons, zbData);
	AddInventarisation (inv.Name + " " + snoekNaam, snIcons, snData);
	
	// The user has to pay for the number of tiles selected.
	if (PublicInformed == true) {
		budget -= (int)((float)inv.Cost * 0.7f);
	} else { 
		budget -= inv.Cost;
	}
	
	// Set some data that scripts can use and 
	// fire the ResearchConducted event
	lastResearch = inv.Name;
	lastResearchGroup = "Inventarisation";
	lastResearchCount = tileCount;
	ResearchConducted ();
} 

void DoSuccession() 
{
	// AREA will be defined to the name of the selection area
	// for this inventarisation. If data is set we are doing
	// an inventarisation...
	foreach (Inventarisation inv in 
		EnumerateActiveInventarisations (AREA)) {
		ProcessInventarisation (inv);
	}
}

// Get all Vens and species data
Data ven0;
Data ven1;
Data ven2;
Data kp;
Data zb;
Data sn;

// Get all data references
void LoadProgress(bool initScene) {
	ven0 = progression.GetData ("Ven0");
	ven1 = progression.GetData ("Ven1");
	ven2 = progression.GetData ("Ven2");
}

// Return selectable area
Data GetSelectableArea (UserInteraction ui) {
	return progression.GetData (selectableArea);
}

// We can always select the tile if it's in the selection area
bool CanSelectTile (int x, int y, UserInteraction ui) {
	return true;
}
}
