
using System.Collections.Generic;
using Ecosim;
using Ecosim.EcoScript;
using Ecosim.SceneData;
using Ecosim.SceneData.AnimalPopulationModel;
using Ecosim.SceneData.VegetationRules;
using Ecosim.SceneData.Action;

public class EcoScript40 : EcoBase
{


	protected const string AREA = "area40";


public readonly InventarisationAction action;

public EcoScript40 (Scene scene, InventarisationAction action) : base (scene, action) {
	this.action = action;
	
		AdKP = (List<int>) scene.progression.variables["AdKP"];

		TileCount = (List<int>) scene.progression.variables["TileCount"];

		ZonneBaars = (List<int>) scene.progression.variables["ZonneBaars"];

		JuvKP = (List<int>) scene.progression.variables["JuvKP"];

		ZBBorderCap = (List<int>) scene.progression.variables["ZBBorderCap"];

		Snoek = (List<int>) scene.progression.variables["Snoek"];

		BreedingAreaKP = (List<int>) scene.progression.variables["BreedingAreaKP"];

		BreedingAreaZB = (List<int>) scene.progression.variables["BreedingAreaZB"];

		JuvKPCatched = (List<int>) scene.progression.variables["JuvKPCatched"];

		IsVerontdiept = (List<bool>) scene.progression.variables["IsVerontdiept"];

}

	protected int ZBCarryingCap {
		get { return (int) scene.progression.variables["ZBCarryingCap"]; }
		set { scene.progression.variables["ZBCarryingCap"] = value; }
	}

	protected readonly List<int> AdKP;

	protected readonly List<int> TileCount;

	protected readonly List<int> ZonneBaars;

	protected float JuvKPMort {
		get { return (float) scene.progression.variables["JuvKPMort"]; }
		set { scene.progression.variables["JuvKPMort"] = value; }
	}

	protected readonly List<int> JuvKP;

	protected readonly List<int> ZBBorderCap;

	protected float ZBMort {
		get { return (float) scene.progression.variables["ZBMort"]; }
		set { scene.progression.variables["ZBMort"] = value; }
	}

	protected readonly List<int> Snoek;

	protected float DispersionVen0To1 {
		get { return (float) scene.progression.variables["DispersionVen0To1"]; }
		set { scene.progression.variables["DispersionVen0To1"] = value; }
	}

	protected float DispersionVen1To0 {
		get { return (float) scene.progression.variables["DispersionVen1To0"]; }
		set { scene.progression.variables["DispersionVen1To0"] = value; }
	}

	protected int JuvKPBorderCap {
		get { return (int) scene.progression.variables["JuvKPBorderCap"]; }
		set { scene.progression.variables["JuvKPBorderCap"] = value; }
	}

	protected int JuvKPCarryingCap {
		get { return (int) scene.progression.variables["JuvKPCarryingCap"]; }
		set { scene.progression.variables["JuvKPCarryingCap"] = value; }
	}

	protected float KPBirthRate {
		get { return (float) scene.progression.variables["KPBirthRate"]; }
		set { scene.progression.variables["KPBirthRate"] = value; }
	}

	protected float ZBPredate {
		get { return (float) scene.progression.variables["ZBPredate"]; }
		set { scene.progression.variables["ZBPredate"] = value; }
	}

	protected float ZBBirthRate {
		get { return (float) scene.progression.variables["ZBBirthRate"]; }
		set { scene.progression.variables["ZBBirthRate"] = value; }
	}

	protected float AdKPMort {
		get { return (float) scene.progression.variables["AdKPMort"]; }
		set { scene.progression.variables["AdKPMort"] = value; }
	}

	protected float JuvToAdRate {
		get { return (float) scene.progression.variables["JuvToAdRate"]; }
		set { scene.progression.variables["JuvToAdRate"] = value; }
	}

	protected float SnoekBirthRate {
		get { return (float) scene.progression.variables["SnoekBirthRate"]; }
		set { scene.progression.variables["SnoekBirthRate"] = value; }
	}

	protected float SnoekBorderCap {
		get { return (float) scene.progression.variables["SnoekBorderCap"]; }
		set { scene.progression.variables["SnoekBorderCap"] = value; }
	}

	protected float SnoekMort {
		get { return (float) scene.progression.variables["SnoekMort"]; }
		set { scene.progression.variables["SnoekMort"] = value; }
	}

	protected float ZBPredateOnSnoek {
		get { return (float) scene.progression.variables["ZBPredateOnSnoek"]; }
		set { scene.progression.variables["ZBPredateOnSnoek"] = value; }
	}

	protected readonly List<int> BreedingAreaKP;

	protected readonly List<int> BreedingAreaZB;

	protected bool GridIsPlaced {
		get { return (bool) scene.progression.variables["GridIsPlaced"]; }
		set { scene.progression.variables["GridIsPlaced"] = value; }
	}

	protected readonly List<int> JuvKPCatched;

	protected bool PublicInformed {
		get { return (bool) scene.progression.variables["PublicInformed"]; }
		set { scene.progression.variables["PublicInformed"] = value; }
	}

	protected bool PermitObtained {
		get { return (bool) scene.progression.variables["PermitObtained"]; }
		set { scene.progression.variables["PermitObtained"] = value; }
	}

	protected bool OverflowIsPlaced {
		get { return (bool) scene.progression.variables["OverflowIsPlaced"]; }
		set { scene.progression.variables["OverflowIsPlaced"] = value; }
	}

	protected float ZBPredateOnZB {
		get { return (float) scene.progression.variables["ZBPredateOnZB"]; }
		set { scene.progression.variables["ZBPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnZB {
		get { return (float) scene.progression.variables["SnoekPredateOnZB"]; }
		set { scene.progression.variables["SnoekPredateOnZB"] = value; }
	}

	protected float SnoekPredateOnSnoek {
		get { return (float) scene.progression.variables["SnoekPredateOnSnoek"]; }
		set { scene.progression.variables["SnoekPredateOnSnoek"] = value; }
	}

	protected readonly List<bool> IsVerontdiept;

	protected int SnoekCarryingCap {
		get { return (int) scene.progression.variables["SnoekCarryingCap"]; }
		set { scene.progression.variables["SnoekCarryingCap"] = value; }
	}

	protected string lastMeasure {
		get { return (string) scene.progression.variables["lastMeasure"]; }
		set { scene.progression.variables["lastMeasure"] = value; }
	}

	protected string lastMeasureGroup {
		get { return (string) scene.progression.variables["lastMeasureGroup"]; }
		set { scene.progression.variables["lastMeasureGroup"] = value; }
	}

	protected int lastMeasureCount {
		get { return (int) scene.progression.variables["lastMeasureCount"]; }
		set { scene.progression.variables["lastMeasureCount"] = value; }
	}

	protected string lastResearch {
		get { return (string) scene.progression.variables["lastResearch"]; }
		set { scene.progression.variables["lastResearch"] = value; }
	}

	protected string lastResearchGroup {
		get { return (string) scene.progression.variables["lastResearchGroup"]; }
		set { scene.progression.variables["lastResearchGroup"] = value; }
	}

	protected int lastResearchCount {
		get { return (int) scene.progression.variables["lastResearchCount"]; }
		set { scene.progression.variables["lastResearchCount"] = value; }
	}
#line 1 "EcoScript40"
// Survey ZB

Data ven0;
Data ven1;
Data ven2;

Inventarisation[] inventarisations;

void LoadProgress(bool initScene) {
	ven0 = progression.GetData ("Ven0");
	ven1 = progression.GetData ("Ven1");
	ven2 = progression.GetData ("Ven2");
	
	string name = "Zonnebaars Ven "; 
	inventarisations = new Inventarisation[]
	{
		new Inventarisation (name+"1", ven1, 0, 0),
		new Inventarisation (name+"2", ven0, 0, 0),
		new Inventarisation (name+"3", ven2, 0, 0)
	};
}

void DoSuccession() {
	// AREA will be defined to the name of the selection area
	// for this inventarisation. If data is set we are doing
	// an inventarisation...
	foreach (Inventarisation inv in 
		inventarisations) //EnumerateActiveInventarisations (AREA))
	{
		// The selection of the inventarisation
		Data selection = inv.SelectionMap;
	
		// the data we are analysing...
		Data analyse = progression.GetData ("ZB");
		
		// the result dataset
		// value 0 is used for all cells not selected in
		// the AREA map (not selected by user).
		SparseBitMap8 icons = new SparseBitMap8 (scene);
		SparseBitMap8 data = new SparseBitMap8 (scene);
		
		int tileCount = 0; // we'll count the number of tiles selected
		foreach (Coordinate vc in selection.EnumerateNotZero ()) {
			tileCount ++;
			int value = analyse.Get (vc);
			// somehow map the values of the data we analyse
			// to the icons set...
			if (value <= 0) {
			}
			else if (value < 4) {
				icons.Set (vc, 1);
			}
			else if (value < 11) {
				icons.Set (vc, 2);
			}
			else if (value < 26) {
				icons.Set (vc, 3);
			}
			else {
				icons.Set (vc, 4);			
			}
			
			// save the actual data
			data.Set (vc, value);
		}
		
		// make the report available. We use the name of the
		// first UI element (the button in game interface
		// for this inventarisation).
		AddInventarisation (inv.Name, icons, data);
		
		// user has to pay for the number of tiles selected.
		budget -= inv.Cost;
	}
}

bool CanSelectTile (int x, int y, UserInteraction ui) {
	return (ven0.Get(x, y) > 0) || (ven1.Get(x, y) > 0) || (ven2.Get(x, y) > 0);
}
}
